

/**
 * Cette classe est une classe squelette pour les autres fonctions
 * @author Tachouct Mustapha
 */
abstract public class AbstractFunction {
  

    /**
     * retourne le nombre de parametre de la fonction
     */
    abstract public int getNumberParameter();

    
    /**
     * retourne f(x)
     */
    abstract public double f(double x);

    /**
     * retourne f(a,b)
     */
    abstract public double f(double a,double b);
    


    /**
     * calcule f(x) pour chaque element de la liste
     */
    abstract public double [] f(double [] x);

    /**
     * calcule f(a,b) pour chaque element de la liste
     */
    abstract public double [] f(double [] a,double[] b);


        
    /**
     * calcul f( P(x) ) ou f ( P(x) , Q(x)) suivant le nombre de parametre
     */
    public double [] f(Polynome P,Polynome Q,double x[]){
	double res1[],res2[];
	
	res1=P.P(x);
	
	if ( getNumberParameter()>=2 ){
	    res2  = Q.P(x);
	    return f(res1,res2);
	}
	
	return f(res1);

    }
    
    abstract public String toString();
    
}
