import java.text.*;
import java.util.*;

/**
 * Analyseur synthaxique
 * @author Tachouct Mustapha
 */
public class Analyser {


	/**
	 * retourne un Polynome
	 */
    static Polynome getPolynome(String s){
	String [] str_expr=splitExpression(s);
	Object  [] obj_expr=splitExpression(str_expr);
	
	return getPolynome(obj_expr);

	
    }

	/**
	 * retourne un Polynome
	 */
    public static Polynome getPolynome( Object obj){

	if (obj instanceof Polynome)
	    return (Polynome)obj;

	if (obj instanceof Double)
	    {
		double [] coeff =new double[1];
		double [] puiss =new double[1];

		coeff[0]=((Double)obj).doubleValue();
		puiss[0]=0;

		return new Polynome(coeff,puiss);
	    }
	if ( obj instanceof Object[]) {
	  
	    return getPolynome((Object[])obj);
	}
	
	throw new ArithmeticException(obj+" is not a number");

    }

	/**
 	* retourne un Polynome
 	*/
    static Polynome getPolynome( Object [] expr_obj){
	Vector l = new Vector();
	 Polynome res=new Polynome(new double[0],new double[0]);

	for ( int i =0 ; i < expr_obj.length ;i++)
	    l.add(expr_obj[i]);
	
	Iterator iter= l.iterator();


	while ( iter.hasNext()){
	    Object obj = iter.next();

	    if ( obj instanceof UnaryOperator){
		Stack UnaryOpStk =new Stack();

		while ( obj instanceof UnaryOperator ){
		    UnaryOpStk.push(obj);
		    iter.remove();
		    obj=iter.next();
		}
		iter.remove();
		
		Polynome P =getPolynome(obj);
		while (! UnaryOpStk.isEmpty())
		    P.mult(-1);

		obj=(Object)P;

	    }
	

	if ( obj instanceof Double || 
	     obj instanceof Polynome ||
	     obj instanceof Object [] ){

	    Polynome P = getPolynome(obj);
	    iter.remove();

	    if ( !iter.hasNext() )
		throw new ArithmeticException(P+" BinaryOperator?");
		    
	    obj = iter.next();
	    if (! (obj instanceof BinaryOperator))
		throw new ArithmeticException(obj+"is not a binary operator");

	    BinaryOperator op =(BinaryOperator)obj;
	    iter.remove();

	    if ( !iter.hasNext() )
		throw new ArithmeticException(P+" BinaryOperator?");
	    Polynome Q=getPolynome(obj);
	    iter.remove();
	    

	   res= op.compute(P,Q);
	    
	} 

			

	}
	

		return res;
    }

    /***************************************************************/
    /**
     * decoupe un chaine en morceau
     */
    static String [] splitExpression(String expr ){
	int char_i=0;
	int char_end =0;
	int string_i=0;
	char c ='\0';
	
	int len = expr.length();
	String [] res = new String [len];
	StringCharacterIterator str = new StringCharacterIterator ( expr);
	
	while ( str.current() != CharacterIterator.DONE ) 
	    {
		c = str.current();
		char_i = str.getIndex();
		
		/* si un chiffre */
		if (isDigit(c) ){
		    /* partie entiere */
		    while (isDigit(c))
			c=str.next();
		    
		    if (c=='.')
			c=str.next();
		    
		    /* partie decimal */
		    while ( isDigit(c) ) 
			c=str.next();
		    
		    res[string_i++]=expr.substring(char_i,str.getIndex());
		    c=str.previous();
		}
		else if ( isOperator(c) ){
		    res[string_i++]=""+c;
		    
		}
		else if ( c=='x' || c=='X'){
		    res[string_i++]="x^1";
		    
		    c=str.next();
		    
		    if ( c== '^' ){
			
			c=str.next();

			/* si un chiffre */
			if ( isDigit(c) ){
			    
			    /* partie entiere */
			    while (isDigit(c))
				c=str.next();
			    
			    if (c=='.')
				c=str.next();
			    
			    /* partie decimal */
			    while ( isDigit(c) ) 
				c=str.next();
			    
			    res[string_i-1]=
				"x"+expr.substring(char_i+1,str.getIndex());
			    
			}
		    }
		    c=str.previous();
		}
		
		else if( isAlpha ( c ) ){
		    
		    while ( isAlpha(c) )
			c=str.next();
		    
		    res[string_i++]=expr.substring(char_i,str.getIndex());
		    
		    
		    c=str.previous();
		}
		if ( isOpen(c) || isClose(c)){
		    res[string_i++]=""+c;
		}
		
		if ( string_i>0 )
		    System.out.println("["+(string_i-1)+"]"+res[string_i-1]);
		
		str.next() ;
		
		if (string_i>1&&res[string_i-1]==null)
		    System.err.println("err ptr=null");
	    }
	
	
	/* recopie : result = res */
	String []result = new String [ string_i];
	System.arraycopy(res,0,result,0, string_i); 
	
	return result;
    }
    /******************************************************************/
    
    /**
     * transforme des morceau en Object ( operateur,double , tableau..)
     */
    static Object [] splitExpression(String [] expr){
	Object [] objects = new Object [expr.length];
	Vector vector = new Vector( expr.length ); 
	Object obj = null;
	Object prev = null;
	String str = null;
	
	for ( int i = 0 ; i< expr.length ; i++ ){
	    
	    
	    str = expr[i];
	    System.out.println(str);
	    if (isOperator(str)){  
		if (i==0 || prev instanceof Operator ) 
		    obj = new UnaryOperator(str);

		else obj = new BinaryOperator(str);
		
	    }
	    else if ( isValue(str)) obj= new Double(str);
	    else if (  isXpowValue(str)){
		double coeff[] = new double [1];
		double puiss[] = new double [1];
		coeff[0]=puiss[0]=1;
		try{
		puiss[0]=Double.parseDouble(str.substring(2,str.length()-2));
		}catch (Exception e)
		    {System.out.println(e);}
		
		obj=new Polynome(coeff,puiss);
	    }
	    else if (isOpen(str)) {
		int open = i+1;
		int close =i+1;
		int current=i+1;
		int nb=1;

		for (;nb>0&&current<expr.length ;current++){
		    
		    if ( isOpen(expr[current]))
			nb++;
		    else if( isClose(expr[current]))
			nb--;
		}
		if ( current>expr.length){
		    System.err.println("manque une parenthese");
		    return null;
		}
		
		close=current-2;
		
		String []subExpression =new String[close-open+1];
		System.arraycopy( expr,open,subExpression,0,
				 subExpression.length);
		obj = (Object) splitExpression(subExpression);
		i=close+1;
	    }
	    else  obj = str;
	   
	    
	    vector.add(obj);
	    prev=obj;
	}

	
	return vector.toArray();
    }
    /******************************************************************/
    
    /**
    *
    * evalue l'objet
    */	
    static double evaluate(Object obj , double x){

       
	if(obj instanceof Object[])
	    return evaluate((Object[])obj,x);

	if (obj instanceof Double){
	    
	    Double d = (Double) obj;
	    return d.doubleValue();
	    
	}

	if ( obj instanceof Operator){
	    throw new ArithmeticException(obj+" is not a number");
	}
	    
	if (obj instanceof String){
	    String str = (String) obj;

	    if (isXpowValue(str)){
		
		double exp =
		    Double.parseDouble(str.substring(2,str.length()-2) );
		
		return  Math.pow( x , exp );
	    }
	    
	    
	}
	
	throw new ArithmeticException(obj+" is not a value");
    }
    
    static double evaluate( Object [] expr, double x){
	return evaluate(expr,0,expr.length,x);
    }
    
    static double evaluate(Object [] expr, int off,int len,double x){
	
	for ( int i = off ; i <off+len ; i++ ){
	    
	    Object obj = expr[i];
	    
	    if ( obj instanceof UnaryOperator ){

		Stack tmp = new  Stack();
		int first = i;
		int end = i+1;
		while ( obj instanceof UnaryOperator){
		    tmp.push(obj);
		    obj=expr[++i];
		}

		end =i;

	      
		Double d = new Double(evaluate(obj,x));
		
		while ( !tmp.isEmpty()){
		    UnaryOperator op = (UnaryOperator)tmp.pop();
		    d=new Double(op.compute(d.doubleValue()));
		}
		
	    }
		
	    
	
	
	}		
	    
	return 0;
    }
    

    
    /******************************************************************/
    
    /**
     * gere l'affiche de l'objet
     */
    static String toString(Object obj){
	Object [] array = null;
	String str="";
	
	/*System.out.print( "["+ obj +"] :");*/
	if ( obj instanceof Operator ) str=""+obj;
	else if ( obj instanceof Double ) str=""+obj;
	else if ( obj instanceof String && isXpowValue((String)obj))
	    str="Xpow";
	else if ( obj instanceof Object[]){
	    array=(Object[])obj;
	    str="[ ";
	    for ( int i = 0 ; i <array.length ;i++)
		str+=toString(array[i])+" ";
	    str+="]";
	}
	return str;
		

    }



    /******************************************************************/
    static boolean isOperator(char c)
    {	return c=='+' || c=='-' || c=='*' || c=='/' || c=='^';}
    static boolean isUnaryOperator(char c)
    {	return c=='-' ; }
    static boolean isBinaryOperator(char c)
    {	return !isUnaryOperator(c);}
    static boolean isDigit(char c)
    {	return c>='0' && c<='9';}
    static boolean isAlpha(char c)
    {	return (c>='a' && c<='z' )||(c>='A' && c<='Z');}
    static boolean isOpen(char c)
    {	return c=='(';}
    static boolean isClose(char c)
    {	return c==')';}
    /******************************************************************/
    static boolean isOperator(String str)
    {	return str.length()==1 && isOperator(str.charAt(0));}
    static boolean isUnaryOperator(String str)
    { 	return str.length()==1 && isUnaryOperator(str.charAt(0)) ; }
    static boolean isBinaryOperator(String str)
    {	return str.length()==1 && isBinaryOperator(str.charAt(0));}
    static boolean isDigit(String str)
    {	return str.length()==1&& isDigit(str.charAt(0) ) ;}
    static boolean isAlpha(String str)
    { 	return str.length()==1 && isAlpha(str.charAt(0));}
    static boolean isOpen(String str)
    { 	return str.length()==1 && isOpen(str.charAt(0)) ;}
    static boolean isClose(String str)
    {	return str.length()==1 && isClose(str.charAt(0));}

    static boolean isXpowValue ( String str ){
	if ( str.charAt(0) != 'x')
	    return false;
	
       	if ( str.charAt(1) !='^' )
	    return false;
		String pow = str.substring( 2 ,str.length()-1);
	if (! isValue(pow))
	    return false;
	
	return true;
    }
    /******************************************************************/
     static boolean isValue(String str)
    {
	int nbPoints =0;char c='\0';

	for ( int i = 0 ; i < str.length() ;i++)
	    { 
		c =str.charAt(0);
		
		/* si  chiffre : OK*/
		if ( isDigit(c) )
		    continue;
		
		
		/* si 1 seul Points : OK */
		if ( c == '.' ){ 
		    nbPoints++;
		 
		    if ( nbPoints>1)
			return false;
		  
		    continue;
		}
		
		/* sinon : ERREUR */
		return 	false;
	    }
	
	return true;
    }
    /******************************************************************/
    static boolean isValid(String [] expr){
	String current="",prev="",next="";
	if ( expr==null)
	    return false;
	if (  expr.length > 0){
	    
	    next=expr[0];
	}
	for ( int i  = 0 ; i < expr.length ;i++ ){
	    
	    prev=current;
	    current=next;
	    next=expr[i];
	}
	
	return true;
	
    }

    static Object [] compute(Object [] objects , double x){
	
	
	for ( int i=0 ; i  <  objects.length ; i++ ){
	    Object obj = objects[i];
	    if (obj instanceof String  && isXpowValue((String)obj)){
		try {
		    String str=(String) obj;
		    double puiss =Double.parseDouble( str.substring(2,str.length()) );
		    
		    obj=(Object) new Double( Math.pow(x,puiss) );
		}catch ( Exception ex)   {System.err.println(ex);}
		
	    } 
		
		
	    objects[i]=obj;
	}
	    
	    
	    return objects;
	} 
	public static void main ( String [] args){

	    System.out.println("Entrer le polynome :");
	    String str=Utils.readString();

	    String split [] =Analyser.splitExpression(str);
	    Object [] objects = splitExpression(split);
	    
	    if ( split==null || objects==null) 
		{
		    System.err.println("err syn"); 
		    return;
		}

	    
	    for ( int i=0; i < objects.length ;i++)
		System.out.print( toString(objects[i])+" " );
	    
	    System.out.println();



	}
}/* fin de la class  */
    
