import java.awt.*;
import java.awt.event.*;

/**
* Cette classe sert a afficher une aire
* @author Tachouct Mustapha
*
*/
class  AreaCanvas extends Canvas {
    double x[],y[];
    double min_x,max_x,min_y,max_y;
    int index[];
    Lagrange lagrange;Newton newton;
    Dimension minimumsize= new Dimension (320,240);
    Polynome P;
    /*Polygon polygon;
      int px[],py[];*/
    
    AreaCanvas( double X[],double Y[])
    {super();x=X;y=Y;init();}
    
    public void init(){
       	min_y=max_y=0;
	newton =new Newton(x,y);P=newton.getPolynome();
	lagrange =new Lagrange(x,y);
	for (int i = 0 ; i < x.length ; i++)
	    {
		min_x=Math.min(min_x,x[i]);
		max_x=Math.max(max_x,x[i]);
		min_y=Math.min(min_y,y[i]);
		min_y=Math.min(min_y,P.P(x[i]));
       		max_y=Math.max(max_y,y[i]);		       
		max_y=Math.max(max_y,P.P(x[i]));
	    }

       
       
       
	index = new int[x.length];
	for ( int i = 0 ; i < index.length ; i++)
	    index[i]=i;

	
	boolean cont = true;
	while ( cont){
	    cont=false;

	    int tmp;

	    for ( int i= 1 ; i < index.length ; i++)
		if ( x[index[i]] >  x[ index[i-1]] ) {

		    tmp=index[i];
		    index[i]=index[i-1];
		    index[i-1]=tmp;


		    cont=true;
		}
	}
	

	/*px=new int [x.length+2];
	  py=new int [x.length+2];*/
	

	newton =new Newton(x,y);P=newton.getPolynome();
	lagrange =new Lagrange(x,y);
    }
    public void setPolygon(){
	/*int width = getWidth()-16;
	int  height=getHeight()-16;
	double zX = width/(max_x-min_x);
	double zY =  height/ (max_y-min_y);
	
	px[0]= 8;
	py[0]=8+height-(int) ((0-min_y)*zY);
	for ( int i=0 ; i< index.length ;i++){
	    px[i+1]= 8+(int) ((x[index[i]]-min_x)*zX);
	    py[i+1]=8+height-(int) ((y[index[i]]-min_y)*zY);
	}

	px[0]= width- 8;
	py[0]=8+height-(int) ((0-min_y)*zY);	


	polygon= new Polygon(px,py,px.length);*/

    }

    public void drawArea(java.awt.Graphics g){
	int width = getWidth()-16;
	int height=getHeight()-16;
	double zX = width/(max_x-min_x);
	double zY =  height/ (max_y-min_y);
	double inc= 4/zX;
	double prev_x,prev_y;


	g.setColor(Color.GREEN);
	for ( double x=min_x ; x<= max_x ;x+=inc)
	    g.drawLine(
		       8+ (int) ((x-min_x)*zX),
		       8+height-(int) ((P.P(x)-min_y)*zY),
		       8+(int) ((x-min_x)*zX),
		       8+height-(int) ((0-min_y)*zY )) ;


	g.drawLine(
		       8+ (int) ((max_x-min_x)*zX),
		       8+height-(int) ((P.P(max_x)-min_y)*zY),
		       8+(int) ((max_x-min_x)*zX),
		       8+height-(int) ((0-min_y)*zY )) ;



    }


    public void paint(java.awt.Graphics g){
	int width = getWidth()-16;
	int  height=getHeight()-16;
	double zX = width/(max_x-min_x);
	double zY =  height/ (max_y-min_y);

	g.setColor(Color.WHITE);
	g.fillRect(0,0,width+16,height+16);

	
	setPolygon();
	drawArea(g);
	drawNewton(g);
	drawAxes(g);

	/*g.setColor(Color.RED);
	  g.fillPolygon(polygon);*/

	/* les axes x et y*/
	/*	g.setColor(Color.RED);
	g.drawLine( 8+(int) ((0-min_x)*zX),
		    8+height-(int) ((0-min_y)*zY ),
	    8+(int) ((0-min_x)*zX),
	    8+height-(int) ((max_y-min_y)*zY)) ;
	
	g.drawLine( 8+(int) ((0-min_x)*zX),
		    8+height-(int) ((0-min_y)*zY ),
	    8+(int) ((max_x-min_x)*zX),
	    8+height-(int) ((0-min_y)*zY)) ;

	g.drawLine( 8+(int) ((1.0-min_x)*zX),
		    8-1+height-(int) ((0-min_y)*zY ),
	    8+(int) ((1.0-min_x)*zX),
	    8+1+height-(int) ((max_y-min_y)*zY)) ;*/
	
	/*	g.drawLine( 8-1+(int) ((0-min_x)*zX),
		    8+height-(int) ((1.0-min_y)*zY ),
	    8+1+(int) ((max_x-min_x)*zX),
	    8+height-(int) ((1.0-min_y)*zY));*/
	


	g.setColor(Color.BLACK);
	g.fillRect( 8-1+(int) ((x[index[0]]-min_x)*zX),
		       8-1+height-(int) ((y[index[0]]-min_y)*zY ),3,3);
	for ( int i=1 ; i< index.length ;i++){
	    g.drawLine(
		       8+(int) ((x[index[i-1]]-min_x)*zX),
		       8+height-(int) ((y[index[i-1]]-min_y)*zY),
		       8+(int) ((x[index[i]]-min_x)*zX),
		       8+height-(int) ((y[index[i]]-min_y)*zY ));
	    

	    g.fillRect( 8-1+(int) ((x[index[i]]-min_x)*zX),
		       8-1+height-(int) ((y[index[i]]-min_y)*zY ),3,3);
	};


	drawNewton(g);
	/*drawLagrange(g);*/
    }

    /*  public void drawLagrange(java.awt.Graphics g){

	int width = getWidth()-16;
	int  height=getHeight()-16;
	double zX = width/(max_x-min_x);
	double zY =  height/ (max_y-min_y);


	g.setColor(Color.RED);
	g.fillRect( 8-1+(int) ((x[index[0]]-min_x)*zX),
		    8-1+height-(int) ((y[index[0]]-min_y)*zY ),3,3);
	for ( int i=1 ; i< index.length ;i++){
	    g.drawLine(
		       8+(int) ((x[index[i-1]]-min_x)*zX),
		       8+height-(int) ((y[index[i-1]]-min_y)*zY),
		       8+(int) ((x[index[i]]-min_x)*zX),
		       8+height-(int) ((y[index[i]]-min_y)*zY ));
	    

	    g.fillRect( 8-1+(int) ((x[index[i]]-min_x)*zX),
		       8-1+height-(int) ((y[index[i]]-min_y)*zY ),3,3);
	};


    */

    public Dimension getMinimumSize(){
	return minimumsize;
    }

    public void drawNewton(java.awt.Graphics g){

	int width = getWidth()-16;
	int  height=getHeight()-16;
	double zX = width/(max_x-min_x);
	double zY =  height/ (max_y-min_y);
	double inc= 1/zX;
	double prev_x,prev_y;


	g.setColor(Color.BLUE);
	for ( double x=min_x ; x< max_x ;x+=inc){
	    g.drawLine(
		       8+ (int) ((x-min_x)*zX),
		       8+height-(int) ((P.P(x)-min_y)*zY),
		       8+(int) ((x+inc-min_x)*zX),
		       8+height-(int) ((P.P(x+inc)-min_y)*zY ) );


	    
    /*
	    g.fillRect( 8-1+(int) ((x[index[i]]-min_x)*zX),
	    8-1+height-(int) ((y[index[i]]-min_y)*zY ),3,3);*/
	};


    }


    public void drawAxes(Graphics g){
	int width = getWidth()-16;
	int  height=getHeight()-16;
	double zX = width/(max_x-min_x);
	double zY =  height/ (max_y-min_y);
	
	g.setColor(Color.RED);
	
	int x = 8+(int) ((0-min_x)*zX);
	int y = 8+(int)+height-(int) ((0-min_y)*zY );
	
	g.drawLine(x,8,x,height+8);
	g.drawLine(8,y,width+8,y);


	
	int x1 =(int) ((1-min_x)*zX);
	int y1 = (int)8+height-(int) ((1-min_y)*zY );
	
	g.drawLine(x1,y-1,x1,y+1);
	g.drawLine(x-1,y1,x+1,y1);
	
    }
    

    public static void main(String []argv){
	Frame f =new Frame("grap");
	AreaCanvas c = new AreaCanvas(Utils.readDoublev(),Utils.readDoublev());
	
	c.setSize(220,225);
	f.add(c);
       
	
	f.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e){
		    System.exit(0);
		}
		
	    });
	
	
	
	f.pack();
	f.show();

	double [] x =new double [10];
	double [] y = new double [10];


	for ( int i = 0 ; i < 10 ; i++){
	    x[i]=i;
	    y[i]=0.1+Math.cos(i/300.0);;
	    

	}
	Frame ff =new Frame("grap");
	AreaCanvas cc = new AreaCanvas(x,y);
	
	cc.setSize(220,225);
	ff.add(cc);
       
	
	ff.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e){
		    System.exit(0);
		}
		
	    });
	
	
	
	ff.pack();
	ff.show();

	

    }

}


