import java.io.*;
/**
 *
 * Cette classe sert a sauvegarder des points
 * @author Tachouct Mustapha
 *
 **/
public class Backup {
    
    private final static int FILE_HEADER=0xCFEFAD;
    
    public static double [][] loadPoints( String fileName ){
	
	try {
	    FileInputStream istream = new FileInputStream(fileName);
	    ObjectInputStream ois = new ObjectInputStream(istream);
	    
	    int header = ois.readInt();
	    if (header!= FILE_HEADER) return null;
	    double [] x = (double [])ois.readObject();
	    double [] f = (double [])ois.readObject();
	    istream.close();
	    
	    double [][] pts = new double [2][];
	    
	    pts[0]=x;
	    pts[1]=f;
	
	    return pts;
	}catch (Exception ex){
	    System.err.println(ex);
	    return null;
	}
    }
    
    
    public static void  savePoints(String fileName, double x[],double  y[]){
	try {
	    FileOutputStream ostream = new FileOutputStream(fileName);
	    ObjectOutputStream oos = new ObjectOutputStream(ostream);
	    
	    oos.writeInt(FILE_HEADER);
	    oos.writeObject(x);
	    oos.writeObject(y);
	    
	    oos.flush();
	    ostream.close();
    	}catch (Exception ex){
	    System.err.println(ex);
	}
	
    }
    
}
