

/**
 * Cette classe permet de calculer la division 
 * de deux nombres ou de deux polynomes
 * @author Tachouct Mustapha
 */
public class Div extends AbstractFunction {
    

    /**
     * constructeur vide
     */
    Div(){}
    
    

    /**
     * retourne le nombre de parametre ( 2 )
     */
    public int getNumberParameter(){
	return 2;
    }
    
    

    /**
     * ne fait rien 
     */
    public double f(double x){
	return x;
    }
    
    
    
    /**
     * retourne a/b
     */
    public double f(double a,double b){
	return a/b;
    }
    
    
    
    /**
     * ne fait rien
     */
    public double [] f(double [] x){
	double []fx =new double[x.length];
	
	for ( int i = 0 ; i < x.length ; i++)
	    fx[i]=f(x[i]);
	
	return fx;
    }
    
    
    
    /**
     * retourne les divisions des deux listes
     */
    public double [] f(double [] a,double[] b){
	double []fx =new double[a.length];
	
	for ( int i = 0 ; i < a.length ; i++)
	    fx[i]=f(a[i],b[i]);
	
	return fx;
	
    }
    
    
    public String toString(){
	return "P(x)/Q(x)";
    }
}
