import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 *	La class IntegrationGraphique est la class permetant de
 *  gerer le projet d'integration de maniere fenetr avec swing
 *  @author Martins Alexandre
 */
 public class IntegrationGraphique implements ActionListener
{ 

	/**
	 *	Ici c'est les atributs utiles comme les elements de la fenetre,
	 *	les instances de simpson et des trapeses et le MyPolynome
	 */
	
	JFrame fenetre;
	Container pane;
	
	JButton ok,quitter;
	JTextField MyPolynome, bSup, bInf, pas, majo;
	JLabel lePoly, laDeri, laBSup, laBInf, lePas, laMajo, deri;
	
	MyPolynome p=null;
	
	double infD,supD,majoD,pasD;
	
	/**
	 * Le constructeur cre juste la fenetre principale mais sans la montrer
	 * il faudra demarer la presentation avec un appelle a start();
	 */
	 	
	public IntegrationGraphique()
	{
		fenetre = new JFrame("Integration polynomiale");
		fenetre.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		pane=fenetre.getContentPane();
		pane.setLayout(new GridLayout(7,2));
		
		ok=new JButton("OK");
		ok.addActionListener(this);
		quitter=new JButton("Quitter");
		quitter.addActionListener(this);
		lePoly=new JLabel("Le polynome a etudier");
		laDeri=new JLabel("La derive seconde du polynome");
		laBSup=new JLabel("La borne superieur");
		laBInf=new JLabel("La borne inferieur");
		lePas=new JLabel("La valeur du pas");
		laMajo=new JLabel("La majoration de l'erreur");
		deri=new JLabel("Entrez un polinome");
		MyPolynome=new JTextField("");
		MyPolynome.setActionCommand("MyPolynome!");
		MyPolynome.addActionListener(this);
		bSup=new JTextField("");
		bInf=new JTextField("");
		pas=new JTextField("");
		majo=new JTextField("");
		pane.add(lePoly);
		pane.add(laDeri);
		pane.add(MyPolynome);
		pane.add(deri);
		pane.add(laBInf);
		pane.add(laBSup);
		pane.add(bInf);
		pane.add(bSup);
		pane.add(lePas);
		pane.add(laMajo);
		pane.add(pas);
		pane.add(majo);
		pane.add(ok);
		pane.add(quitter);
		fenetre.pack();
	}
	
	/**
	 *	Ce constructeur sert a definir le point d'entre
	 *	lors d'un debut dans la partie interpolation
	 */
	
	public IntegrationGraphique(double [] coefficients, double [] puissances)
	{
		p=new MyPolynome(coefficients,puissances);
		fenetre = new JFrame("Integration polynomiale");
		fenetre.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		pane=fenetre.getContentPane();
		pane.setLayout(new GridLayout(7,2));
		
		ok=new JButton("OK");
		ok.addActionListener(this);
		quitter=new JButton("Quitter");
		quitter.addActionListener(this);
		lePoly=new JLabel("Le polynome a etudier");
		laDeri=new JLabel("La derive seconde du polynome");
		laBSup=new JLabel("La borne superieur");
		laBInf=new JLabel("La borne inferieur");
		lePas=new JLabel("La valeur du pas");
		laMajo=new JLabel("La majoration de l'erreur");
		deri=new JLabel(p.derive().derive().toString());
		MyPolynome=new JTextField(p.toString());
		MyPolynome.setActionCommand("MyPolynome!");
		MyPolynome.addActionListener(this);
		bSup=new JTextField("");
		bInf=new JTextField("");
		pas=new JTextField("");
		majo=new JTextField("");
		pane.add(lePoly);
		pane.add(laDeri);
		pane.add(MyPolynome);
		pane.add(deri);
		pane.add(laBInf);
		pane.add(laBSup);
		pane.add(bInf);
		pane.add(bSup);
		pane.add(lePas);
		pane.add(laMajo);
		pane.add(pas);
		pane.add(majo);
		pane.add(ok);
		pane.add(quitter);
		fenetre.pack();
		
		
	}
	
	/**
	 *	C'est la gestion des actions
	 *	il y a le faite d'entrer un MyPolynome,
	 *	de quitter la fenetre
	 *	et de la valider;
	 */
	
	public void actionPerformed(ActionEvent e)	
	{
		if(e.getActionCommand().equals("MyPolynome!"))
		{
			getMyPolynome gp=new getMyPolynome(fenetre);
			p=gp.MyPolynome();
			fenetre.hide();
			pane.removeAll();
			MyPolynome=new JTextField(p.toString());
			deri=new JLabel(p.derive().derive().toString());
			pane.add(lePoly);
			pane.add(laDeri);
			pane.add(MyPolynome);
			pane.add(deri);
			pane.add(laBInf);
			pane.add(laBSup);
			pane.add(bInf);
			pane.add(bSup);
			pane.add(lePas);
			pane.add(laMajo);
			pane.add(pas);
			pane.add(majo);
			pane.add(ok);
			pane.add(quitter);
			fenetre.pack();
			fenetre.show();
		}
		if(e.getActionCommand().equals("Quitter"))
		{ 
			fenetre.hide();
			System.exit(0);
		}
		if(e.getActionCommand().equals("OK"))
		{
			try
			{
				infD=Double.parseDouble(bInf.getText());
				supD=Double.parseDouble(bSup.getText());
				pasD=Double.parseDouble(pas.getText());
				majoD=Double.parseDouble(majo.getText());				
			}catch(Exception excp){}
			
			if(supD<=infD||p==null)
				return;
			
			fenetre.hide();
			new Resultat(p,infD,supD,pasD,majoD).view();
		}
		
		
	}
	
	/**
	 *	C'est la fonction pour demarer la fenetre
	 */	
		
	public void start()
	{
		
		fenetre.show();
	}
	
	
}





