import java.awt.*;
import java.awt.event.*;

/**
 * Cette classe est la classe principale
 * @author Tachouct Mustapha
 */
public class  InterpolationFrame extends Frame {
    
    GridLayout mainlayout,intervallayout ;
    Panel operationpanel,polynomepanel,intervalpanel,mainpanel;
    Label operationlabel =new Label("Operation : ");
    Label polynomelabel = new Label("Polynome(s) :");
    Label intervallabel =new Label("interval : ");
    Label precisionlabel = new Label("precision :");
    Label majorationlabel =new Label("majoration :");
    List list ;
    TextField ptextfield= new TextField("",30);
    TextField qtextfield= new TextField("",30);
    TextField precisiontextfield= new TextField("0.1",8);
    TextField intervalmintextfield =new TextField("0.0",8);
    TextField intervalmaxtextfield =new TextField("1.0",8);
    TextField majorationtextfield =new TextField("1.0");
    Button graphiquebutton =new Button("graphique");
    Button airebutton = new Button("aire");
    Button informationbutton =new Button("information");
    long timer =0;

   
    /*Button addpointbutton = new Button("ajouter point");*/
    Polynome P=null,Q=null;
    Newton newton=null;Lagrange lagrange=null;
    Polynome newtonpolynome,lagrangepolynome;
    AbstractFunction fcts []={ new Cos(),new Sin(), new Exp(),new Log(),
			      new Sqrt(),new Div(),new Abs(),new Rand()};
    double min=0 , max = 1 , precision=0.1, majoration = 1,erreur=0;
    double newtonerreur=0,lagrangeerreur=0;
    int nbpoints;

    double [] x;double [] fx;

    Frame THIS;
    
    InterpolationFrame()
    {super();init();}
    
    InterpolationFrame(String s)
    {super(s);init();}

    public void setOperationLayout(){
	operationpanel=new Panel(new BorderLayout());setList();
	operationlabel.setAlignment(Label.CENTER);
	operationpanel.add(operationlabel,BorderLayout.NORTH);
	operationpanel.add(list,BorderLayout.CENTER);
    }

    public void setList(){
	list=new List(3);
	for ( int  i = 0 ; i < fcts.length ;i++)
	    list.add(""+fcts[i]);
	list.select(0);

    }

    public void setPolynomeLayout(){
	polynomepanel=new Panel(new BorderLayout());
	Panel west = new Panel();
	west.setLayout(new GridLayout(2,1));
	Panel center = new Panel();
	center.setLayout(new GridLayout(2,1));
	
	west.add(new Label("  P(x) : "));
	west.add(new Label("  Q(x) : "));
	
	center.add(ptextfield);
	center.add(qtextfield);
	
	polynomelabel.setAlignment(Label.CENTER);
	polynomepanel.add(polynomelabel,BorderLayout.NORTH);

	polynomepanel.setName("-------");
	polynomepanel.add(west,BorderLayout.WEST);
	polynomepanel.add(center,BorderLayout.CENTER);
	
    }

    public void setIntervalLayout(){
	intervallayout=new GridLayout(2,5);
	intervalpanel =new Panel(intervallayout);
	intervallabel.setAlignment(Label.RIGHT);
	precisionlabel.setAlignment(Label.RIGHT);
	majorationlabel.setAlignment(Label.RIGHT);

	intervalpanel.add(intervallabel);
	intervalpanel.add( intervalmintextfield);
	intervalpanel.add( intervalmaxtextfield);
	intervalpanel.add(precisionlabel);
	intervalpanel.add(precisiontextfield);
	intervalpanel.add(majorationlabel);
	intervalpanel.add(majorationtextfield);

	intervalpanel.add(graphiquebutton);
	intervalpanel.add(airebutton);
	/*intervalpanel.add(addpointbutton);*/
	intervalpanel.add(informationbutton);

    }
    
    public void setMainLayout(){
	mainpanel =new Panel(new BorderLayout());
	mainlayout=new GridLayout(1,2);
	
	/*mainpanel.setLayout(mainlayout);*/
	mainpanel.add(BorderLayout.WEST,operationpanel);
	mainpanel.add(BorderLayout.CENTER,polynomepanel);
	mainpanel.add(BorderLayout.SOUTH,intervalpanel);
	

	this.add(mainpanel);
    }

    
    public void init(){
	THIS=this;
	setEvent();
	setOperationLayout();
	setPolynomeLayout();
	setIntervalLayout();
	setMainLayout();	
    }

    public void setEvent(){
	
	ptextfield.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e){}
		public void mouseReleased(MouseEvent e){}
		public void mouseExited(MouseEvent e){}
		public void mouseEntered(MouseEvent e){}
		public void mouseClicked(MouseEvent e){
		    P=GraphicsPolynome.getPolynome(THIS);
		    ptextfield.setText(""+P);
		    THIS.pack();
		    THIS.show();
		}

	    });

	qtextfield.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e){}
		public void mouseReleased(MouseEvent e){}
		public void mouseExited(MouseEvent e){}
		public void mouseEntered(MouseEvent e){}
		public void mouseClicked(MouseEvent e){
		     Q=GraphicsPolynome.getPolynome(THIS);
		     qtextfield.setText(""+Q);
		     THIS.pack();
		     THIS.show();
		}

	    });

	intervalmintextfield.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){

		    try{ 
			min=Double.parseDouble(intervalmintextfield.getText());
		    }catch(Exception ex){intervalmintextfield.setText(""+min);}
		}
	    });

	intervalmaxtextfield.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){

		    try{ 
			max=Double.parseDouble(intervalmaxtextfield.getText());
		    }catch(Exception ex)
			{intervalmaxtextfield.setText(""+max);}
		}
	    });

	majorationtextfield.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){

		    try{ 
			majoration=Double.parseDouble(majorationtextfield.getText());
		    }catch(Exception ex)
			{majorationtextfield.setText(""+majoration);}
		}
	    });
	
	precisiontextfield.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){

		    try{ 
			precision=
			    Double.parseDouble(precisiontextfield.getText());
		    }catch(Exception ex)
			{precisiontextfield.setText(""+precision);}
		}
	    });
	
	graphiquebutton.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    if (P==null || min==max)
			return;
		    if ( Q==null)
			Q=new Polynome(new double[0],new double[0]);
		    try{ 
			max=Double.parseDouble(intervalmaxtextfield.getText());
			min=Double.parseDouble(intervalmintextfield.getText());
			precision=
			    Double.parseDouble(precisiontextfield.getText());
		    }catch(Exception ex)
			{return;}

		    
		    try{ 
			majoration=Double.parseDouble(majorationtextfield.getText());
		    }catch(Exception ex){}

			majorationtextfield.setText(""+majoration);
		    
		    if (min>max){
			double tmp=min;min=max;max=tmp;
		    }
		     AbstractFunction f = fcts[list.getSelectedIndex()];
		     nbpoints= 1 + (int)((max-min)/precision);
		     x=new double[nbpoints];
		     double xi=min;
		     for ( int i = 0 ; i< nbpoints ; i++,xi+=precision)
			 x[i]=xi;
		     fx=f.f(P,Q,x);
		     
		     final Dialog frame =new Dialog(THIS);
		     frame.setTitle("graphique");
		     GraphicsCanvas c = new GraphicsCanvas(x,fx);
		     
		     c.setSize(220,225);
		     frame.add(c);
		     
		     
		     frame.addWindowListener(new WindowAdapter(){
			     public void windowClosing(WindowEvent e){
				 frame.dispose();
			     }
			     
			 });
		     
		     
		     frame.setModal(true);
		     frame.pack();
		     frame.show();
		     
		     
		    
		}
	    });
	

	airebutton.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){

		     if (P==null || min==max)
			return;
		    if ( Q==null)
			Q=new Polynome(new double[0],new double[0]);
		    try{ 
			max=Double.parseDouble(intervalmaxtextfield.getText());
			min=Double.parseDouble(intervalmintextfield.getText());
			precision=
			    Double.parseDouble(precisiontextfield.getText());
			majoration=
			    Double.parseDouble(majorationtextfield.getText());
		    }catch(Exception ex)
			{return;}

		    
		    
		    if (min>max){
			double tmp=min;min=max;max=tmp;
		    }
		     AbstractFunction f = fcts[list.getSelectedIndex()];
		     nbpoints= 1 + (int)((max-min)/precision);
		     x=new double[nbpoints];
		     double xi=min;
		     for ( int i = 0 ; i< nbpoints ; i++,xi+=precision)
			 x[i]=xi;
		     fx=f.f(P,Q,x);
		     
		     final Dialog frame =new Dialog(THIS);
		     frame.setTitle("graphique");
		     AreaCanvas c = new AreaCanvas(x,fx);
		     
		     c.setSize(220,225);
		     frame.add(c);
		     
		     
		     frame.addWindowListener(new WindowAdapter(){
			     public void windowClosing(WindowEvent e){
				 frame.dispose();
			     }
			     
			 });
		     
		     
		     frame.setModal(true);
		     frame.pack();
		     frame.show();
		     
		        
		}

		
	    });
	




	informationbutton.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    if (P==null || min==max)
			return;
		    if ( Q==null)
			Q=new Polynome(new double[0],new double[0]);
		    
		    
		    if (min>max){
			double tmp=min;min=max;max=tmp;
		    }
		    
		    try{ 
			majoration=Double.parseDouble(majorationtextfield.getText());
		    }catch(Exception ex){}
		    majorationtextfield.setText(""+majoration);
		    
		    AbstractFunction f = fcts[list.getSelectedIndex()];
		    nbpoints= 1 + (int)((max-min)/precision);
		    x=new double[nbpoints];
		    double xi=min;
		    System.out.println("------ Information   -------");

		    setTimer();
		    System.out.print("Construction des points");
		    for ( int i = 0 ; i< nbpoints ; i++,xi+=precision)
			x[i]=xi;
		    fx=f.f(P,Q,x);
		    System.out.println("\t"+getTimer());
		    
		    setTimer();
		     System.out.print("Interpolation : Newton");
		     newton =new Newton(x,fx);
		     System.out.println("\ttemps="+getTimer()+"ms");
		     
		     setTimer();
		     System.out.print("Interpolation :Lagrange");
		     lagrange =new Lagrange(x,fx);
		     System.out.println("\ttemps="+getTimer()+"ms");
		     
		     setTimer();
		     System.out.print("polynome : Newton");
		     newtonpolynome=newton.getPolynome();
		     System.out.println("\ttemps="+getTimer()+"ms");

		     setTimer();
		     System.out.print("polynome : Lagrange");
		     lagrangepolynome=lagrange.getPolynome();
		     System.out.println("\ttemps="+getTimer()+"ms");
   
		    
	
		     String p="";
		     
		     p+="\n\n-----------------------------Aire----------------------------\n\n";
		     setTimer();
		     System.out.print("Calcul d'aire : trapeze");
		     p+="Trapeze:\n";
		     Trapeze trapeze = new Trapeze(newtonpolynome,min,max);
	
		     p+="aire="+Math.abs(trapeze.valeur(precision))+"\t";
		     p+="\terreur="+Math.abs(trapeze.erreur(precision,majoration));
		    System.out.println("\ttemps="+getTimer()+"ms");

		     setTimer();
		     System.out.print("Calcul d'aire : simpson");
		     p+="\n\nSimpson:\n";
		     Simpson simpson =new Simpson(newtonpolynome,min,max);
		     p+="aire="+Math.abs(simpson.valeur(precision))+"\t";
		     p+="\terreur="+Math.abs(simpson.erreur(precision,majoration))+"\n";
		    System.out.println("\ttemps="+getTimer()+"ms");
		    
		    System.out.flush();
	

	     String s= "-------------Interpolation-----------\n\n";

		     s+= "Newton:\n"+newton+"\n\n";
		     s+="Lagrange:\n"+lagrange;
		     s+= "\n\n\nPolynome :\n";
		     
		     s+="\tLagrange : "+lagrangepolynome+"\n";
		     s+="\tNewtion : "+newtonpolynome+"\n";
		     s+="\tNewton-Lagrage : "+
			 Polynome.sub(newtonpolynome,
				      lagrangepolynome)+"\n";
		     
		     
		     newtonerreur=0;
		     lagrangeerreur=0;
		     
		     /***   recherche de l'erreur maximal */
		     for ( double x=min+precision/2 ; x<max ; x+=precision)
			 {
			     
			     newtonerreur=
				 Math.max(newtonerreur,newton.getError(x,majoration));
			     
			     lagrangeerreur=
				 Math.max(lagrangeerreur,lagrange.getError(x,majoration));
			     
			 }
		     /*****/
		     s+="\nerreur maximum: Newton="+newtonerreur+"\tLagrange="+lagrangeerreur+"\n";
		     
		     



			/*****/
			
		     TextArea textarea = new TextArea(s+p);
		     textarea.setEditable(false);
final Dialog frame =new Dialog(THIS);
		     frame.setTitle("information");
		     frame.add(textarea);
		     
		     
		     frame.addWindowListener(new WindowAdapter(){
			     public void windowClosing(WindowEvent e){
				 frame.dispose();
			     }
			     
			 });
		     
		     
		     frame.setModal(true);
		     frame.pack();
		     frame.show();
		     

		}
	    });
	

	/*	addpointbutton.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    if ( newton ==null || lagrange==null)
			return;

		    final Dialog frame =new Dialog(THIS);
		    TextField  xtextfield =new TextField("x",8);
		    TextField  ytextfield =new TextField("",8);
		    Label question = new Label("Point ?");
		    Button ok = new Button("Ok");
		    question.setAlignment(Label.CENTER);
		    frame.setTitle("ajouter un point");
		    frame.setLayout(new BorderLayout());
		    frame.add(BorderLayout.NORTH,question);
		    frame.add(BorderLayout.EAST,xtextfield);
		    frame.add(BorderLayout.WEST,ytextfield);
		    frame.add(BorderLayout.SOUTH,ok);
		    frame.setModal(true);
		    frame.pack();
		    frame.show();
		    
		    
		    }
		});
	   
	*/
    }
    
    
    public void setTimer(){
	timer= System.currentTimeMillis();
    }

    public long getTimer(){
	return System.currentTimeMillis()-timer;
    }

   

    public void start(){

	InterpolationFrame f = new InterpolationFrame("Interpolation");
	

	/*f.add( new Label("Interpolation") , BorderLayout.NORTH);*/


		f.setSize(640,480);
		f.pack();
		/*f.setResizable(false);*/
	f.show();



    }
    
    public static void main(String [] args){

	InterpolationFrame f = new InterpolationFrame("Interpolation");
	f.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e){
		    System.exit(0);
		}
		
	    });

	/*f.add( new Label("Interpolation") , BorderLayout.NORTH);*/


		f.setSize(640,480);
		f.pack();
		/*f.setResizable(false);*/
	f.show();



    }

}
