import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 *	Cette class est la premiere interface avec l'utilisateur
 *	Elle lui permet de choisir de debutter soit par l'interpolation
 *	ou par l'integration
 *  @author Martins Alexandre
 *
 */  
public class MenuMath implements ActionListener
{
    JFrame fenetre; 
    JButton interpolation, integration;
  
  	/**
  	 *	Le constructeur est direct, il affiche le menu
  	 *	et attend les ordre de l'utilisateur
  	 */
    
    public MenuMath()
    { 
	fenetre = new JFrame("Projet de mathematique");
	fenetre.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	fenetre.getContentPane().setLayout(new BorderLayout());
	interpolation = new JButton("Interpolation");
	interpolation.addActionListener(this);
	integration = new JButton("Integration");
	integration.addActionListener(this);
	fenetre.getContentPane().add(interpolation,BorderLayout.NORTH);
	fenetre.getContentPane().add(integration,BorderLayout.SOUTH);
	fenetre.pack();
	fenetre.show();
    }    
    
    /**
     *	C'est la gestion des actions
     */
    
    public void actionPerformed(ActionEvent e)
    {
	if(e.getActionCommand().equals("Interpolation"))
	    {
			(new InterpolationFrame()).start();
	    }
	if(e.getActionCommand().equals("Integration"))
	    {
			(new IntegrationGraphique()).start();
	    }
    }
}