/**
 *	La class MyPolynome est la classe permettant les calcules
 *	au niveau de l'integration
 *	Ceci est du au decoupage du projet en deux.
 *  @author Martins Alexandre
 */
public class MyPolynome
{
	/**
	 *	La fonction toString est la pour mettre en format texte le polynome
	 */
    public String toString()
    {
	String ret="";
	for(int i=0;i<coefficient.length-1;i++)
	    {
		ret+=coefficient[i]+"x^("+puissance[i]+") + ";
	    }
	ret+=coefficient[coefficient.length-1]+"x^("+puissance[puissance.length-1]+")";
	return ret;
    }

    double [] coefficient;
    double [] puissance;

	/**
 	 *	le constructeur 
 	 */

    public MyPolynome(double [] coefficient, double [] puissance)
    {
	this.coefficient=coefficient;
	this.puissance=puissance;
    }

	/**
	 *	derive() sert a deriver une fois le polynome
	 *	Si il faut deriver n fois le polynome, appelez la fonction
	 *	n fois.
	 */

    public MyPolynome derive()
    {
	if(puissance.length==1 && puissance[0]==0)
	    return new MyPolynome(new double[]{0.0},new double[]{0.0});
	int longueur=puissance.length;
	for(int i=0;i<puissance.length;i++)
	    if(puissance[i]==0)
		longueur--;
	double [] calcule= new double[longueur];
	double [] puiss= new double[longueur];
	longueur=0;
	for(int i=0;i<coefficient.length;i++)
	    {
		if(puissance[i]!=0)
		    {
			calcule[longueur]=coefficient[i]*puissance[i];
			puiss[longueur]=puissance[i]-1;
			longueur++;
		    }
	    }
	return new MyPolynome(calcule,puiss);
    }

	/**
	 *	Integre calcule l'integrale du polynome a la constante pres
	 */

    public MyPolynome integre()
    {
	double [] calcule= new double[coefficient.length+1];
	double [] puiss = new double[coefficient.length+1];
	for(int i=0;i<coefficient.length;i++)
	    {
		calcule[i]=coefficient[i]/(puissance[i]+1);
		puiss[i]=puissance[i]+1;
	    }
	return new MyPolynome(calcule,puiss);
    }
    
    /**
     *	f(x) calcule l'image de x par la fonction defini
     *	par le polynome
     */
    
    public double f(double x)
    {
	double ret=0;
	double courant;
	for(int i=0;i<coefficient.length;i++)
	    {
			courant=coefficient[i];
			courant*=Math.pow(x,puissance[i]);
			ret+=courant;
	    }
	return ret;
    }
    
}