import java.awt.*;
import java.awt.event.*;

/**
 * Cette classe permet de saisir des points
 * @author Tachouct Mustapha
 */
public class  PointsFrame extends Frame {
    
    GridLayout mainlayout,pointslayout,nbpointslayout ;
    Panel mainpanel,pointspanel,nbpointspanel;
    ScrollPane pointspane;
    Label operationlabel =new Label("Operation : ");
    List list ;
    TextField nbtextfield= new TextField("5",10);
    TextField qtextfield= new TextField("",20);
    TextField tabpoints [][]=null;
    Button savebutton =new Button("save"),loadbutton=new Button("load");
    Label emptylabel =new Label("");
    int N;int MAX_N = 1024;
    double x[] ={ 1, 2, 3, 4, 5};
    double y[] ={ 1, 4, 9 ,16,25}; 
    
    PointsFrame(int nb)
    {super();N=nb;init();}
    
    PointsFrame(String s)
    {super(s);N=5;init();}

    public void init(){
	setTabPoints();
	setEvent();
	setNbPointsLayout();
	setPointsLayout();
	setMainLayout();
	setClose();
       
    }

    public void setTabPoints(){
	tabpoints =new TextField[MAX_N][];
	for (int i = 0  ; i< MAX_N ; i++) {
	    tabpoints[i]=new TextField[2];
	    tabpoints[i][0]=new TextField("0.0",10);
	    tabpoints[i][1]=new TextField("0.0",10);
	}

    }
    public void updateTabPoints(){

	pointspanel.removeAll();
	pointslayout=new GridLayout(N+1,4);
	
	pointspanel.setLayout(pointslayout);

	Label xlabel =new Label("x");
	Label fxlabel =new Label("f(x)");
	

	xlabel.setAlignment(Label.CENTER);
	fxlabel.setAlignment(Label.CENTER);

	pointspanel.add( emptylabel);
	pointspanel.add( xlabel);
	pointspanel.add( fxlabel);
	pointspanel.add( new Label(""));

	for ( int i = 0 ; i < N ; i++){

	    Label numlabel = new Label(""+i);
	    numlabel.setAlignment(Label.RIGHT);

	    pointspanel.add(numlabel );
	    pointspanel.add( tabpoints[i][0]);
	    pointspanel.add( tabpoints[i][1] );
	    pointspanel.add( new Label(""));
	    }
	
	pointspane = new ScrollPane(){
		public Dimension getMaximumSize(){
		    return new Dimension(240,400);
		}
		

	    };;

	pointspane.add(pointspanel);

	this.add(pointspane,BorderLayout.CENTER);

	
	/*setPointsLayout();*/
	
    }

    public void setNbPointsLayout(){
	nbpointspanel =new Panel();
	nbpointspanel.setLayout(new GridLayout(1,4));
	nbpointspanel.add(new Label("Nb points : "));
	nbpointspanel.add(nbtextfield);
	nbpointspanel.add(savebutton);
	nbpointspanel.add(loadbutton);
    }

    public void setPointsLayout(){

	pointspanel=new Panel();
	
	pointslayout=new GridLayout(N+1,4);
	
	pointspanel.setLayout(pointslayout);

	Label xlabel =new Label("x");
	Label fxlabel =new Label("f(x)");


	xlabel.setAlignment(Label.CENTER);
	fxlabel.setAlignment(Label.CENTER);

	pointspanel.add( emptylabel);
	pointspanel.add( xlabel);
	pointspanel.add( fxlabel);
	pointspanel.add( new Label(""));

	for ( int i = 0 ; i < N ; i++){

	    Label numlabel = new Label(""+i);
	    numlabel.setAlignment(Label.RIGHT);

	    pointspanel.add(numlabel );
	    pointspanel.add( tabpoints[i][0]);
	    pointspanel.add( tabpoints[i][1] );
	    pointspanel.add( new Label(""));
	    }
	
	pointspane = new ScrollPane(){
		public Dimension getMaximumSize(){
		    return new Dimension(240,400);
		}
		

	    };;
	pointspane.add(pointspanel);



	/*	List list = new List(N);
	for ( int i = 0 ; i < N ; i++)
	list.add(new TextField("",20));*/

	/*pointspanel.add(list);*/
	
    }

    public void setMainLayout(){
	this.add(nbpointspanel,BorderLayout.NORTH);
	this.add(pointspane,BorderLayout.CENTER);
	/*this.add(new GraphicsCanvas(x,y),BorderLayout.SOUTH);*/
	
    }

    public void setClose(){
	this.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e){
		    dispose();
		}

	    });

    }


    public void setEvent(){
	savebutton.addActionListener( new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    Component c =(Component)e.getSource();

		    while ( ! ( c instanceof Frame))
			{
			    c=(Component)c.getParent();
			}
		    Frame f = (Frame)c;

		    FileDialog fd =new FileDialog(f," ",FileDialog.LOAD);
		    fd.show();

		    String file =fd.getFile();
		    if ( file==null)
			return;

		    Backup.savePoints(file,x,y);

		}
	    });

	loadbutton.addActionListener( new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    Component c =(Component)e.getSource();

		    while ( ! ( c instanceof Frame))
			{
			    c=(Component)c.getParent();
			}
		    Frame f = (Frame)c;

		    FileDialog fd =new FileDialog(f,null,FileDialog.SAVE);
		    fd.show();
		    String file =fd.getFile();
		    if ( file==null)
			return;
		    
		    double [][]pts=Backup.loadPoints(file);

		    if(pts==null)
			return ;
		    N=pts[0].length;
		    x=pts[0];
		    y=pts[1];
		    updateTabPoints();
		    /*		    remove(nbpointspanel);
				    remove(pointspane);*/
		    /*		    setLayout(new BorderLayout());*/
		    /*init();*/
		   

		}
	    });
	
	nbtextfield.addActionListener( new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    try {
			N= Integer.parseInt(nbtextfield.getText());
		    }catch( Exception ex){}
		    
		    if (N<=0)
			N=1;
		    nbtextfield.setText(""+N);
		    /*		    .removeAll();*/
		    init();
		    /*setPointsLayout();*/
		    
		}
	    });
	
    }



    public static void main(String [] args){

	PointsFrame f = new PointsFrame("");
	

	/*f.add( new Label("Interpolation") , BorderLayout.NORTH);*/


	f.setSize(321,240);
	f.pack();
	f.show();
	


    }


}
