import java.io.*;
import java.util.*;

/**
 * Cette classe outils permet delire des listes de points au clavier
 * @author Tachouct Mustapha
 */
public class Utils {

    public static final String DELIM = " ,:\t";

    public static String readString(){

	BufferedReader in = null;
	String ret= null;
	
	in =  new BufferedReader( new InputStreamReader(System.in) );
		
	try {
	    ret = in.readLine();
	}
	catch (IOException ex) {
	    System.err.println(ex);
	    return null;
	}
	
	
	return ret;
    }
    
    public static double [] readDoublev(){
	String str;
	StringTokenizer st;
	double tab []; 
       
	str = readString();
	st  =  new StringTokenizer(str,DELIM );
	tab  =  new double [ st.countTokens() ];

	for ( int i = 0 ;  i < tab.length ; i++)
	    tab[i] = Double.parseDouble(st.nextToken());

	return tab;
    }
    

    public static double readDouble(){
	String str;
	str = readString();
	return Double.parseDouble(str);
    }


    public static void main (String [] args){
	double X[],F[];
	Newton newton;
	Lagrange lagrange;
	double x;
	
	/* les Xi */
	System.out.print("x = \t");
	X=readDoublev();
	
	/* les Fi */
	System.out.print("f(x)=\t");
	F=readDoublev();

	/* L'interpolation */
	System.out.println("Newton :");
	newton = new Newton( X , F );
	lagrange = new Lagrange ( X, F);

	System.out.println("Newton::addPoint()");
	double pts[]=readDoublev();
	newton.addPoint(pts[0],pts[1]);

	newton.print("A");
	newton.print("DD");

	/*  */
	System.out.print("x0 =\t");x=readDouble();
	System.out.println("P(x0)= " + newton.P(x) );

	System.out.println("Newton");
	System.out.println(""+newton.getPolynome());
	System.out.println("Lagrange");
	System.out.println(""+lagrange.getPolynome());
	
    }




}
